#include "thread"

void Thread::lock() {
    if (!initialized) {
	if (int res = pthread_mutex_init (&thread_mutex, 0))
	    throw static_cast<Error>("Failed to initialize mutex: ") +
		strerror(res);
	initialized = true;
    }
    if (int res = pthread_mutex_lock (&thread_mutex))
	throw static_cast<Error>("Failed to obtain mutex lock: ") +
	    strerror(res);
}
